test-lib: self-test that --verbose works
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
c2116a17
JH
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
3c8f12c9
JH
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29fi
30if test -z "$TEST_OUTPUT_DIRECTORY"
31then
32 # Similarly, override this to store the test-results subdir
33 # elsewhere
34 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
35fi
36GIT_BUILD_DIR="$TEST_DIRECTORY"/..
37
2006f0ad
RR
38################################################################
39# It appears that people try to run tests without building...
40"$GIT_BUILD_DIR/git" >/dev/null
41if test $? != 1
42then
43 echo >&2 'error: you do not seem to have built git yet.'
44 exit 1
45fi
46
3c8f12c9
JH
47. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48export PERL_PATH SHELL_PATH
49
4cde519f
RR
50# if --tee was passed, write the output not only to the terminal, but
51# additionally to the file test-results/$BASENAME.out, too.
52case "$GIT_TEST_TEE_STARTED, $* " in
53done,*)
54 # do not redirect again
55 ;;
56*' --tee '*|*' --va'*)
57 mkdir -p test-results
58 BASE=test-results/$(basename "$0" .sh)
59 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
60 echo $? > $BASE.exit) | tee $BASE.out
61 test "$(cat $BASE.exit)" = 0
62 exit
63 ;;
64esac
65
e1970ce4
JH
66# For repeatability, reset the environment to known value.
67LANG=C
899460f3 68LC_ALL=C
d9bdd39e 69PAGER=cat
e1970ce4 70TZ=UTC
c2116a17
JH
71TERM=dumb
72export LANG LC_ALL PAGER TERM TZ
8ff99e74 73EDITOR=:
661bfd13
SL
74# A call to "unset" with no arguments causes at least Solaris 10
75# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
76# deriving from the command substitution clustered with the other
77# ones.
3c8f12c9 78unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 79 my @env = keys %ENV;
730477f1
JL
80 my $ok = join("|", qw(
81 TRACE
82 DEBUG
83 USE_LOOKUP
84 TEST
85 .*_TEST
86 PROVE
87 VALGRIND
ac001282 88 UNZIP
edb54081 89 PERF_
730477f1
JL
90 ));
91 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
92 print join("\n", @vars);
93')
5adf84eb 94unset XDG_CONFIG_HOME
29e55cd5
JH
95GIT_AUTHOR_EMAIL=author@example.com
96GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
97GIT_COMMITTER_EMAIL=committer@example.com
98GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 99GIT_MERGE_VERBOSITY=5
f8246281
JH
100GIT_MERGE_AUTOEDIT=no
101export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
102export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
103export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 104export EDITOR
e1970ce4 105
a731fa91
EP
106# Add libc MALLOC and MALLOC_PERTURB test
107# only if we are not executing the test with valgrind
1b3185fc 108if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 109 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
110then
111 setup_malloc_check () {
112 : nothing
113 }
114 teardown_malloc_check () {
115 : nothing
116 }
117else
118 setup_malloc_check () {
119 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
120 export MALLOC_CHECK_ MALLOC_PERTURB_
121 }
122 teardown_malloc_check () {
123 unset MALLOC_CHECK_ MALLOC_PERTURB_
124 }
125fi
a731fa91 126
886a3907
JH
127# Protect ourselves from common misconfiguration to export
128# CDPATH into the environment
129unset CDPATH
130
5565f47c 131unset GREP_OPTIONS
ac001282 132unset UNZIP
5565f47c 133
3d5c0cc9 134case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756
RJ
1351|2|true)
136 echo "* warning: Some tests will not work if GIT_TRACE" \
137 "is set as to trace on STDERR ! *"
138 echo "* warning: Please set GIT_TRACE to something" \
139 "other than 1, 2 or true ! *"
140 ;;
6ce4e61f
CC
141esac
142
cd3c095c
JH
143# Convenience
144#
145# A regexp to match 5 and 40 hexdigits
146_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
147_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
148
3749fde5
JH
149# Zero SHA-1
150_z40=0000000000000000000000000000000000000000
151
3f4ab627
JH
152# Line feed
153LF='
154'
155
342e9ef2
TR
156export _x05 _x40 _z40 LF
157
e1970ce4
JH
158# Each test should start with something like this, after copyright notices:
159#
160# test_description='Description of this test...
161# This test checks if command xyzzy does the right thing...
162# '
163# . ./test-lib.sh
c2116a17
JH
164[ "x$ORIGINAL_TERM" != "xdumb" ] && (
165 TERM=$ORIGINAL_TERM &&
166 export TERM &&
167 [ -t 1 ] &&
168 tput bold >/dev/null 2>&1 &&
169 tput setaf 1 >/dev/null 2>&1 &&
170 tput sgr0 >/dev/null 2>&1
171 ) &&
55db1df0 172 color=t
e1970ce4 173
e1970ce4
JH
174while test "$#" -ne 0
175do
176 case "$1" in
177 -d|--d|--de|--deb|--debu|--debug)
178 debug=t; shift ;;
886856ab
JH
179 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
180 immediate=t; shift ;;
5e2c08c6 181 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 182 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 183 -h|--h|--he|--hel|--help)
570f3226 184 help=t; shift ;;
e1970ce4
JH
185 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
186 verbose=t; shift ;;
1ece1274 187 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
188 # Ignore --quiet under a TAP::Harness. Saying how many tests
189 # passed without the ok/not ok details is always an error.
190 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
191 --with-dashes)
192 with_dashes=t; shift ;;
55db1df0 193 --no-color)
faa4bc35 194 color=; shift ;;
4e1be63c 195 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
196 valgrind=memcheck
197 shift ;;
198 --valgrind=*)
199 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
200 shift ;;
44138559
JS
201 --tee)
202 shift ;; # was handled already
f423ef5f
JK
203 --root=*)
204 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
205 shift ;;
e1970ce4 206 *)
1f729dca 207 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
208 esac
209done
210
952af351
TR
211test -n "$valgrind" && verbose=t
212
1c0cc756
RJ
213if test -n "$color"
214then
55db1df0 215 say_color () {
c2116a17
JH
216 (
217 TERM=$ORIGINAL_TERM
218 export TERM
55db1df0 219 case "$1" in
1c0cc756
RJ
220 error)
221 tput bold; tput setaf 1;; # bold red
222 skip)
b8fc855a 223 tput setaf 4;; # blue
e8e51955
AS
224 warn)
225 tput setaf 3;; # brown/yellow
1c0cc756 226 pass)
0a6d4751 227 tput setaf 2;; # green
1c0cc756 228 info)
0a6d4751 229 tput setaf 6;; # cyan
1c0cc756
RJ
230 *)
231 test -n "$quiet" && return;;
55db1df0
PH
232 esac
233 shift
5099b99d 234 printf "%s" "$*"
55db1df0 235 tput sgr0
b8eecafd 236 echo
c2116a17 237 )
55db1df0
PH
238 }
239else
240 say_color() {
1ece1274 241 test -z "$1" && test -n "$quiet" && return
55db1df0 242 shift
7bc0911d 243 printf "%s\n" "$*"
55db1df0
PH
244 }
245fi
246
247error () {
248 say_color error "error: $*"
6e7b5aaf 249 GIT_EXIT_OK=t
55db1df0
PH
250 exit 1
251}
252
253say () {
254 say_color info "$*"
255}
256
570f3226
MB
257test "${test_description}" != "" ||
258error "Test script did not set test_description."
259
260if test "$help" = "t"
261then
262 echo "$test_description"
263 exit 0
264fi
265
4d9d62fa 266exec 5>&1
781f76b1 267exec 6<&0
e1970ce4
JH
268if test "$verbose" = "t"
269then
270 exec 4>&2 3>&1
271else
272 exec 4>/dev/null 3>/dev/null
273fi
274
275test_failure=0
276test_count=0
41ac414e
JH
277test_fixed=0
278test_broken=0
2d84e9fb 279test_success=0
e1970ce4 280
d998bd4a
ÆAB
281test_external_has_tap=0
282
faa4bc35 283die () {
6e7b5aaf
CB
284 code=$?
285 if test -n "$GIT_EXIT_OK"
286 then
287 exit $code
288 else
289 echo >&5 "FATAL: Unexpected exit with code $code"
290 exit 1
291 fi
faa4bc35
CB
292}
293
6e7b5aaf 294GIT_EXIT_OK=
35641310 295trap 'die' EXIT
41184273 296
12a29b1a
TR
297# The user-facing functions are loaded from a separate file so that
298# test_perf subshells can have them too
3c8f12c9 299. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 300
886856ab
JH
301# You are not expected to call test_ok_ and test_failure_ directly, use
302# the text_expect_* functions instead.
303
304test_ok_ () {
d5d9de1b 305 test_success=$(($test_success + 1))
5099b99d 306 say_color "" "ok $test_count - $@"
e1970ce4
JH
307}
308
886856ab 309test_failure_ () {
d5d9de1b 310 test_failure=$(($test_failure + 1))
5e5c006e 311 say_color error "not ok $test_count - $1"
bf0dd8a8 312 shift
5099b99d 313 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 314 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
315}
316
41ac414e 317test_known_broken_ok_ () {
41ac414e 318 test_fixed=$(($test_fixed+1))
b73d9a23 319 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
320}
321
322test_known_broken_failure_ () {
41ac414e 323 test_broken=$(($test_broken+1))
e8e51955 324 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 325}
886856ab
JH
326
327test_debug () {
8e832ebc 328 test "$debug" = "" || eval "$1"
e1970ce4
JH
329}
330
e6a6ddc9
TR
331match_pattern_list () {
332 arg="$1"
333 shift
334 test -z "$*" && return 1
335 for pattern_
336 do
337 case "$arg" in
338 $pattern_)
339 return 0
340 esac
341 done
342 return 1
343}
344
a7c58f28
JN
345test_eval_ () {
346 # This is a separate function because some tests use
347 # "return" to end a test_expect_success block early.
781f76b1 348 eval </dev/null >&3 2>&4 "$*"
a7c58f28
JN
349}
350
4d9d62fa 351test_run_ () {
b6b0afdc 352 test_cleanup=:
b586744a 353 expecting_failure=$2
a57397b0 354 setup_malloc_check
a7c58f28 355 test_eval_ "$1"
b6b0afdc 356 eval_ret=$?
a57397b0 357 teardown_malloc_check
b586744a
JH
358
359 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
360 then
1b3185fc 361 setup_malloc_check
a7c58f28 362 test_eval_ "$test_cleanup"
1b3185fc 363 teardown_malloc_check
b586744a 364 fi
1c0cc756
RJ
365 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
366 then
57e1538a
ÆAB
367 echo ""
368 fi
aa0bcf96 369 return "$eval_ret"
4d9d62fa
PR
370}
371
ae75342c 372test_start_ () {
8586f98b 373 test_count=$(($test_count+1))
ae75342c
TR
374}
375
376test_finish_ () {
377 echo >&3 ""
378}
379
380test_skip () {
04ece593 381 to_skip=
e6a6ddc9
TR
382 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
383 then
384 to_skip=t
385 fi
05236a5e
JN
386 if test -z "$to_skip" && test -n "$test_prereq" &&
387 ! test_have_prereq "$test_prereq"
a7bb3940
JS
388 then
389 to_skip=t
390 fi
04ece593
JH
391 case "$to_skip" in
392 t)
07431fc8 393 of_prereq=
05236a5e 394 if test "$missing_prereq" != "$test_prereq"
07431fc8 395 then
05236a5e 396 of_prereq=" of $test_prereq"
07431fc8
JN
397 fi
398
55db1df0 399 say_color skip >&3 "skipping test: $@"
07431fc8 400 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
401 : true
402 ;;
403 *)
404 false
405 ;;
406 esac
407}
408
342e9ef2
TR
409# stub; perf-lib overrides it
410test_at_end_hook_ () {
411 :
412}
413
e1970ce4 414test_done () {
6e7b5aaf 415 GIT_EXIT_OK=t
2d84e9fb 416
517cd55f
TR
417 # Note: t0000 relies on $HARNESS_ACTIVE disabling the .counts
418 # output file
1c0cc756
RJ
419 if test -z "$HARNESS_ACTIVE"
420 then
342e9ef2 421 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 422 mkdir -p "$test_results_dir"
dd78478f
FC
423 base=${0##*/}
424 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
8ef1abe5 425
c54e6be7
ML
426 cat >>"$test_results_path" <<-EOF
427 total $test_count
428 success $test_success
429 fixed $test_fixed
430 broken $test_broken
431 failed $test_failure
432
433 EOF
8ef1abe5 434 fi
41ac414e
JH
435
436 if test "$test_fixed" != 0
437 then
b73d9a23 438 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
439 fi
440 if test "$test_broken" != 0
441 then
e8e51955 442 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
443 fi
444 if test "$test_broken" != 0 || test "$test_fixed" != 0
445 then
446 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
447 msg="remaining $test_remaining test(s)"
11d54b8b 448 else
b73d9a23 449 test_remaining=$test_count
11d54b8b 450 msg="$test_count test(s)"
41ac414e 451 fi
e1970ce4 452 case "$test_failure" in
10b94e28 453 0)
5099b99d 454 # Maybe print SKIP message
bf4b7219
RJ
455 if test -n "$skip_all" && test $test_count -gt 0
456 then
457 error "Can't use skip_all after running some tests"
458 fi
5099b99d
ÆAB
459 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
460
1c0cc756
RJ
461 if test $test_external_has_tap -eq 0
462 then
b73d9a23 463 if test $test_remaining -gt 0
d87bd7c1
RJ
464 then
465 say_color pass "# passed all $msg"
466 fi
d998bd4a
ÆAB
467 say "1..$test_count$skip_all"
468 fi
abc5d372
JS
469
470 test -d "$remove_trash" &&
471 cd "$(dirname "$remove_trash")" &&
472 rm -rf "$(basename "$remove_trash")"
473
342e9ef2
TR
474 test_at_end_hook_
475
e1970ce4
JH
476 exit 0 ;;
477
478 *)
1c0cc756
RJ
479 if test $test_external_has_tap -eq 0
480 then
d998bd4a
ÆAB
481 say_color error "# failed $test_failure among $msg"
482 say "1..$test_count"
483 fi
5099b99d 484
e1970ce4
JH
485 exit 1 ;;
486
487 esac
488}
489
e4597aae 490if test -n "$valgrind"
4e1be63c 491then
4e1be63c
JS
492 make_symlink () {
493 test -h "$2" &&
494 test "$1" = "$(readlink "$2")" || {
495 # be super paranoid
496 if mkdir "$2".lock
497 then
498 rm -f "$2" &&
499 ln -s "$1" "$2" &&
500 rm -r "$2".lock
501 else
502 while test -d "$2".lock
503 do
504 say "Waiting for lock on $2."
505 sleep 1
506 done
507 fi
508 }
509 }
510
511 make_valgrind_symlink () {
36bfb0e5
JK
512 # handle only executables, unless they are shell libraries that
513 # need to be in the exec-path. We will just use "#!" as a
514 # guess for a shell-script, since we have no idea what the user
515 # may have configured as the shell path.
516 test -x "$1" ||
517 test "#!" = "$(head -c 2 <"$1")" ||
518 return;
4e1be63c
JS
519
520 base=$(basename "$1")
6cec5c68 521 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
522 # do not override scripts
523 if test -x "$symlink_target" &&
524 test ! -d "$symlink_target" &&
525 test "#!" != "$(head -c 2 < "$symlink_target")"
526 then
527 symlink_target=../valgrind.sh
528 fi
efd92ffd
JS
529 case "$base" in
530 *.sh|*.perl)
531 symlink_target=../unprocessed-script
532 esac
4e1be63c
JS
533 # create the link, or replace it if it is out of date
534 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
535 }
536
537 # override all git executables in TEST_DIRECTORY/..
538 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
539 mkdir -p "$GIT_VALGRIND"/bin
6cec5c68 540 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
4e1be63c
JS
541 do
542 make_valgrind_symlink $file
543 done
ee0d7bf9
TR
544 # special-case the mergetools loadables
545 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
efd92ffd
JS
546 OLDIFS=$IFS
547 IFS=:
548 for path in $PATH
549 do
550 ls "$path"/git-* 2> /dev/null |
551 while read file
552 do
553 make_valgrind_symlink "$file"
554 done
555 done
556 IFS=$OLDIFS
4e1be63c
JS
557 PATH=$GIT_VALGRIND/bin:$PATH
558 GIT_EXEC_PATH=$GIT_VALGRIND/bin
559 export GIT_VALGRIND
952af351
TR
560 GIT_VALGRIND_MODE="$valgrind"
561 export GIT_VALGRIND_MODE
1c0cc756
RJ
562elif test -n "$GIT_TEST_INSTALLED"
563then
e4597aae
MO
564 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
565 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 566 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
567 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
568else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 569 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
570 if ! test -x "$git_bin_dir/git"
571 then
572 if test -z "$with_dashes"
573 then
e4597aae
MO
574 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
575 fi
576 with_dashes=t
577 fi
578 PATH="$git_bin_dir:$PATH"
6cec5c68 579 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
580 if test -n "$with_dashes"
581 then
6cec5c68 582 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 583 fi
4e1be63c 584fi
6cec5c68 585GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 586unset GIT_CONFIG
8bfa6bd6 587GIT_CONFIG_NOSYSTEM=1
3c995beb 588GIT_ATTR_NOSYSTEM=1
8f323c00 589export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 590
5e87eae9
JH
591if test -z "$GIT_TEST_CMP"
592then
593 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
594 then
595 GIT_TEST_CMP="$DIFF -c"
596 else
597 GIT_TEST_CMP="$DIFF -u"
598 fi
599fi
600
6cec5c68 601GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 602export GITPERLLIB
6cec5c68 603test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
604 error "You haven't built things yet, have you?"
605}
e1970ce4 606
ac10a857 607if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 608then
6cec5c68 609 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
2fe40b63 610 export GITPYTHONLIB
6cec5c68 611 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
2fe40b63
SR
612 error "You haven't built git_remote_helpers yet, have you?"
613 }
614fi
615
1c0cc756
RJ
616if ! test -x "$GIT_BUILD_DIR"/test-chmtime
617then
56cf9806
EW
618 echo >&2 'You need to build test-chmtime:'
619 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
620 exit 1
621fi
622
e1970ce4 623# Test repository
002d4ce8
JK
624TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
625test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
626case "$TRASH_DIRECTORY" in
627/*) ;; # absolute path is good
628 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 629esac
91c8b825 630test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
38b074de 631rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 632 GIT_EXIT_OK=t
8d14ac94
JH
633 echo >&5 "FATAL: Cannot prepare test area"
634 exit 1
635}
636
90cff968
AR
637HOME="$TRASH_DIRECTORY"
638export HOME
639
1c0cc756
RJ
640if test -z "$TEST_NO_CREATE_REPO"
641then
38b074de 642 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 643else
38b074de 644 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 645fi
1bd9c648
LW
646# Use -P to resolve symlinks in our working directory so that the cwd
647# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 648cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 649
d5d9de1b
JS
650this_test=${0##*/}
651this_test=${this_test%%-*}
e6a6ddc9
TR
652if match_pattern_list "$this_test" $GIT_SKIP_TESTS
653then
654 say_color info >&3 "skipping test $this_test altogether"
655 skip_all="skip all tests in $this_test"
656 test_done
657fi
f17e9fbb 658
8648732e
BC
659# Provide an implementation of the 'yes' utility
660yes () {
661 if test $# = 0
662 then
663 y=y
664 else
665 y="$*"
666 fi
667
668 while echo "$y"
669 do
670 :
671 done
672}
673
f17e9fbb
JS
674# Fix some commands on Windows
675case $(uname -s) in
676*MINGW*)
677 # Windows has its own (incompatible) sort and find
678 sort () {
679 /usr/bin/sort "$@"
680 }
681 find () {
682 /usr/bin/find "$@"
683 }
5397ea31
JS
684 sum () {
685 md5sum "$@"
686 }
4114156a
JS
687 # git sees Windows-style pwd
688 pwd () {
689 builtin pwd -W
690 }
ee9fb68c 691 # no POSIX permissions
6fd1106a 692 # backslashes in pathspec are converted to '/'
fb9a2bea 693 # exec does not inherit the PID
a94114ad 694 test_set_prereq MINGW
cfa96496 695 test_set_prereq NOT_CYGWIN
a31d0665
RJ
696 test_set_prereq SED_STRIPS_CR
697 ;;
698*CYGWIN*)
699 test_set_prereq POSIXPERM
a31d0665
RJ
700 test_set_prereq EXECKEEPSPID
701 test_set_prereq NOT_MINGW
cfa96496 702 test_set_prereq CYGWIN
a31d0665 703 test_set_prereq SED_STRIPS_CR
ee9fb68c
JS
704 ;;
705*)
706 test_set_prereq POSIXPERM
6fd1106a 707 test_set_prereq BSLASHPSPEC
fb9a2bea 708 test_set_prereq EXECKEEPSPID
3ba9ba8f 709 test_set_prereq NOT_MINGW
cfa96496 710 test_set_prereq NOT_CYGWIN
f17e9fbb
JS
711 ;;
712esac
704a3143 713
b082687c 714( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 715test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 716test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 717test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 718test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 719
bb946bba 720# Can we rely on git's output in the C locale?
30955229
JN
721if test -n "$GETTEXT_POISON"
722then
723 GIT_GETTEXT_POISON=YesPlease
724 export GIT_GETTEXT_POISON
5e9637c6 725 test_set_prereq GETTEXT_POISON
30955229
JN
726else
727 test_set_prereq C_LOCALE_OUTPUT
728fi
bb946bba 729
cabdee2c
JH
730# Use this instead of test_cmp to compare files that contain expected and
731# actual output from git commands that can be translated. When running
732# under GETTEXT_POISON this pretends that the command produced expected
733# results.
734test_i18ncmp () {
735 test -n "$GETTEXT_POISON" || test_cmp "$@"
736}
737
127df8c6
JH
738# Use this instead of "grep expected-string actual" to see if the
739# output from a git command that can be translated either contains an
740# expected string, or does not contain an unwanted one. When running
741# under GETTEXT_POISON this pretends that the command produced expected
742# results.
743test_i18ngrep () {
744 if test -n "$GETTEXT_POISON"
745 then
746 : # pretend success
747 elif test "x!" = "x$1"
748 then
749 shift
750 ! grep "$@"
751 else
752 grep "$@"
753 fi
754}
755
20073274
AS
756test_lazy_prereq PIPE '
757 # test whether the filesystem supports FIFOs
758 rm -f testfifo && mkfifo testfifo
759'
760
04083f27
JH
761test_lazy_prereq SYMLINKS '
762 # test whether the filesystem supports symbolic links
763 ln -s x y && test -h y
764'
c91cfd19 765
ac39aa61
MG
766test_lazy_prereq CASE_INSENSITIVE_FS '
767 echo good >CamelCase &&
768 echo bad >camelcase &&
769 test "$(cat CamelCase)" != good
770'
771
5b0b5dd4
MG
772test_lazy_prereq UTF8_NFD_TO_NFC '
773 # check whether FS converts nfd unicode to nfc
774 auml=$(printf "\303\244")
775 aumlcdiar=$(printf "\141\314\210")
776 >"$auml" &&
777 case "$(echo *)" in
778 "$aumlcdiar")
779 true ;;
780 *)
781 false ;;
782 esac
783'
784
09feffb6
JK
785test_lazy_prereq AUTOIDENT '
786 sane_unset GIT_AUTHOR_NAME &&
787 sane_unset GIT_AUTHOR_EMAIL &&
788 git var GIT_AUTHOR_IDENT
789'
790
c91cfd19
ÆAB
791# When the tests are run as root, permission tests will report that
792# things are writable when they shouldn't be.
793test -w / || test_set_prereq SANITY
f838ce58
JK
794
795GIT_UNZIP=${GIT_UNZIP:-unzip}
796test_lazy_prereq UNZIP '
797 "$GIT_UNZIP" -v
798 test $? -ne 127
799'